C     Copyright (C) 2007 B. Roukema et al. <shape-univ at astro.uni.torun.pl>
C     
C     This program is free software; you can redistribute it and/or modify
C     it under the terms of the GNU General Public License as published by
C     the Free Software Foundation; either version 2 of the License, or
C     (at your option) any later version.
C     
C     This program is distributed in the hope that it will be useful,
C     but WITHOUT ANY WARRANTY; without even the implied warranty of
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU General Public License for more details.
C     
C     You should have received a copy of the GNU General Public License
C     along with this program; if not, write to the Free Software
C     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C  
C     See also http://www.gnu.org/licenses/gpl.html

      subroutine analys(infiles,ninfiles)

C     INPUTS:
      character*(*)  infiles     ! file listing input files
      integer        ninfiles    ! number of characters in  indir

c      integer        iverb,nowarn ! flags: verbose, suppress warnings


C     INTERNAL:
      character*256  infil2 ! safe string version of indir
      parameter(maxf=30) ! max number of files
      character*256  filename(maxf)

      character*256  line

      parameter(maxn=40000,npars=8)
      real*4         params(maxn,npars,maxf)
      integer*4      nsteps(maxf)

c     cumulators and means for an individual file
      real*4         glongi(maxf),glati(maxf)
      real*4         alphai(maxf),phii(maxf)
      real*4         x_lbi(maxf),y_lbi(maxf),z_lbi(maxf)
      real*4         x_phii(maxf),y_phii(maxf)

      logical*4      test
      logical*4      NaNfound   ! have we found a NaN ?
      logical*4      maxexists(maxf) ! does a maximum exist for this ifil ?

      parameter(pi=3.14159265359,pi_180=pi/180,pi_5=pi/5)

      parameter(tol=1e-4)
      parameter(tolvar=1e-8)

      test= .false. !.true. ! 

      nburnin= 2000
      pmin= 0.6
      ball= 45.0                ! degrees
     _     * pi_180
      b_alpha= 10.0 ! degrees   ! for alpha
     _     * pi_180

      niter=13 ! 3

c     ----------------------------------------------------------------
c     -   read in each line starting "mcmc: pars", get list of  8 parameters
c     -  (l,b)_orig, (l,b)_highb, theta, alpha, phase, pmcnew
c     ----------------------------------------------------------------

      infil2=infiles(1:min(ninfiles,256))

      ifil=0
      open(1,file=infil2,access='sequential',status='old')

      do while(1+1.eq.2)
         read(1,'(a)',end=777)line
         ich=1
         do while(ich.le.256.and.line(ich:ich).ne.' ')
            ich=ich+1
         enddo
         ich=ich-1
         ifil=ifil+1
         print*,'File ',ifil,' is:'
         print*,line(1:ich)
         filename(ifil)= line(1:ich)

         open(2,file=filename(ifil),access='sequential',status='old')

         istep=0

         do while(istep.lt.maxn) ! may stop earlier
c            line='____________'   ! dummy line to be sure to have 12 chars
            do i=1,12
               line(i:i)='_'
            enddo
            do i=13,100
               line(i:i)=' '
            enddo
            read(2,'(a)',end=888)line

c            print*,filename(ifil),'hmm',line

            if(line(1:12).eq.'mcmc: pars= ')then


cmcmc: pars=   195.296   56.976 195.296  56.976   36.8  29.82   0.70  0.401
               ich=71
               do while(ich.le.256.and.line(ich:ich).ne.' ')
                  ich=ich+1
               enddo
               ich=ich-1


               NaNfound = .false.
               do jch=13,ich-2
                  if(line(jch:jch+2).eq.'NaN' .or.
     _                 line(jch:jch+2).eq.'nan' .or. 
     _                 line(jch:jch+2).eq.'NAN')
     _                 NaNfound = .true.
               enddo

               if(test)then
                  print*,filename(ifil),':: '
                  print*,line(13:ich)
               endif

               if(.not.(NaNfound))then
                  istep=istep+1
                  read(line(13:ich),*)
     _                 (params(istep,ipar,ifil),ipar=1,npars)
               endif
c               write(6,'(8g10.4)')
c     _              (params(istep,ipar,ifil),ipar=1,npars)

c     -- read in params (istep, ., ifil)
c            else                ! test only
c               print*,filename(ifil),'?? ',line(1:ich)
            endif

         enddo

 888     continue
         close(2)
         nsteps(ifil) = istep

      enddo

 777  continue
      close(1)
      nfiles= ifil
      do i=1,nfiles
         print*,'file: ',i,'  nsteps(.) = ',nsteps(i)
      enddo

c     -----------------------------------------------------------------
c     - convert (l,b) to xyz_lb
c     - convert phase to xy_phase
c     
c     - add xyz_lb, alpha, xy_phase to averaging cumulators
c     -----------------------------------------------------------------

      do iter=1,niter

         if(iter.eq.3)then      ! tighten the ball
            ball=ball/2.0
            b_alpha=b_alpha/2.0
         endif

         x_lb=0.0
         y_lb=0.0
         z_lb=0.0
         x_phi=0.0
         y_phi=0.0

         glong=0.0
         glat=0.0
         alpha=0.0
         phi=0.0
         ivalid=0
         ihtot=0  ! sum of ihigh's 

c     --- means across ifil numbers (files) ---
         x_lbm=0.0
         y_lbm=0.0
         z_lbm=0.0
         x_phim=0.0
         y_phim=0.0

         glongs=0.0
         glats=0.0
         alphas=0.0
         phis=0.0

         do ifil=1,nfiles
            ihigh=0
            alphai(ifil)=0.0
            maxexists(ifil)= .false.
            do istep=nburnin+1,nsteps(ifil)
               if( 
c     _              (iter.eq.1 .and. params(istep,8,ifil).gt.pmin)
c     _              .or.(iter.ge.2)
     _              (params(istep,8,ifil).gt.pmin)
     _              )
     _              then

                  dx_lb=
     _                 cos( params(istep,4,ifil) * pi_180 )* ! b
     _                 cos( params(istep,3,ifil) * pi_180 ) ! l
                  dy_lb =
     _                 cos( params(istep,4,ifil) * pi_180 )*
     _                 sin( params(istep,3,ifil) * pi_180 )
                  dz_lb = sin( params(istep,4,ifil) * pi_180 )

                  if(iter.ge.2)
     _                 a1 = angle(dx_lb,dy_lb,dz_lb, 
     _                 x_lb1,y_lb1,z_lb1) ! radians

                  dalpha= params(istep,6,ifil)
                  if(iter.ge.2)
     _                 a2= abs(dalpha - alpha1) *pi_180 ! radians

                  dx_phi= cos( params(istep,7,ifil) *pi_5 )
                  dy_phi= sin( params(istep,7,ifil) *pi_5 )
                  if(iter.ge.2)
     _                 a3= acos(max(-1.0+tol, min(1.0-tol, (
     _                 dx_phi*x_phi1 + dy_phi*y_phi1 )))) ! radians

                  if( (iter.eq.1).or.
     _                 (iter.gt.1 .and.
     _                 a1.lt.ball .and. a2.lt.b_alpha .and.
     _                 a3.lt.ball)
     _                 )then
                     ihigh=ihigh+1

c     --- in principle, (l,b) = pars(1,2) or closest to North Pole (3,4)
c     should be used with theta and gendodec ---

                     
                     x_lb = x_lb + dx_lb
                     y_lb = y_lb + dy_lb
                     z_lb = z_lb + dz_lb
                     alphai(ifil)=alphai(ifil) + dalpha

                     x_phi = x_phi + dx_phi
                     y_phi = y_phi + dy_phi
                  endif
               endif
            enddo               !  do istep=nburnin+1,nsteps(ifil)

            if(ihigh.ge.1)then
               x_lb= x_lb/real(ihigh)
               y_lb= y_lb/real(ihigh)
               z_lb= z_lb/real(ihigh)
               x_lbi(ifil)= x_lb
               y_lbi(ifil)= y_lb
               z_lbi(ifil)= z_lb
               if(x_lb*x_lb + y_lb*y_lb + z_lb*z_lb.gt.
     _              tol*tol)then
                  call xyz_rda(x_lb,y_lb,z_lb, rr,dd,aa)
                  glongi(ifil)= aa*15.0
                  glati(ifil)= dd
               else
                  print*,'WARNING: mean (l,b) vec is close to zero:'
                  print*,'x_lb,y_lb,z_lb=',x_lb,y_lb,z_lb
               endif
               
               alphai(ifil)= alphai(ifil)/real(ihigh)
               
               x_phi= x_phi/real(ihigh)
               y_phi= y_phi/real(ihigh)
               x_phii(ifil)= x_phi
               y_phii(ifil)= y_phi
               if(abs(x_phi*x_phi+y_phi*y_phi).gt.tol*tol)then
                  phii(ifil)= atan2(y_phi,x_phi) /pi_180
               else
                  print*,'WARNING: mean phi vec is close to zero:'
                  print*,'x_phi,y_phi=',x_phi,y_phi
               endif
               
               print*,'ifil,ihigh,glong,glat,alpha,phi='
               print*,'means: ',ifil,ihigh,
     _              glongi(ifil),glati(ifil),
     _              alphai(ifil),phii(ifil)
               
               ivalid=ivalid+1
               maxexists(ifil)= .true.
               glong=glong+ glongi(ifil)
               glat=glat+ glati(ifil)
               alpha=alpha+ alphai(ifil)
               phi=phi+ phii(ifil)

               x_lbm=x_lbm+ x_lbi(ifil)
               y_lbm=y_lbm+ y_lbi(ifil)
               z_lbm=z_lbm+ z_lbi(ifil)

               x_phim=x_phim+ x_phii(ifil)
               y_phim=y_phim+ y_phii(ifil)

               glongs=glongs+ glongi(ifil)*glongi(ifil)
               glats=glats+ glati(ifil)*glati(ifil)
               alphas=alphas+ alphai(ifil)*alphai(ifil)
               phis=phis+ phii(ifil)*phii(ifil)

            else
               print*,'ifil,ihigh,glong,glat,alpha,phi='
               print*,'means: ',ifil,ihigh,' NaN,  NaN,  NaN,  NaN' 
            endif

            ihtot=ihtot + ihigh

         enddo                  ! do ifil=1,nfiles

         if(ivalid.ge.1)then
c            glong=glong/real(ivalid)
c            glat=glat/real(ivalid)
            alpha=alpha/real(ivalid)
c            phi=phi/real(ivalid)
            
            x_lbm=x_lbm/real(ivalid)
            y_lbm=y_lbm/real(ivalid)
            z_lbm=z_lbm/real(ivalid)
            if(x_lbm*x_lbm + y_lbm*y_lbm + z_lbm*z_lbm.gt.
     _              tol*tol)then
               call xyz_rda(x_lbm,y_lbm,z_lbm, rr,dd,aa)
               glong= aa*15.0
               glat= dd
            else
               glong= -9.9e9
               glat= -9.9e9
            endif

            x_phim=x_phim/real(ivalid)
            y_phim=y_phim/real(ivalid)
            if(abs(x_phim*x_phim+y_phim*y_phim).gt.tol*tol)then
               phi= atan2(y_phim,x_phim) /pi_180
            else
               phi= -9.9e9
            endif


            if(1+1.eq.3.and.ivalid.ge.2)then  ! standard errors in the mean
               glongs=sqrt(max(tolvar, 
     _              glongs/real(ivalid)-glong*glong))/
     _              sqrt(real(ivalid)-1)
               glats=sqrt(max(tolvar, 
     _              glats/real(ivalid)-glat*glat))/
     _              sqrt(real(ivalid)-1)
               alphas=sqrt(max(tolvar, 
     _              alphas/real(ivalid)-alpha*alpha))/
     _              sqrt(real(ivalid)-1)
               phis=sqrt(max(tolvar, 
     _              phis/real(ivalid)-phi*phi))/
     _              sqrt(real(ivalid)-1)
            else
               glongs= -9.9e9
               glats= -9.9e9
               alphas= -9.9e9
               phis= -9.9e9
            endif
         endif


         print*,'iter=',iter,': ihtot, glong,glat,alpha,phi='
         print*,'means:: ',ihtot,glong,glat,
     _        alpha,phi
c     TODO: calculate these correctly
c         print*,'std-err-m:: ',ihtot,glongs,glats,
c     _        alphas,phis
         print*,' '

         if(iter.lt.niter)then  ! this estimate will be used in next iteration
            x_lb1=cos(glat *pi_180) * cos(glong *pi_180)
            y_lb1=cos(glat *pi_180) * sin(glong *pi_180)
            z_lb1=sin(glat *pi_180)
            alpha1=alpha
            x_phi1= cos(phi *pi_180)
            y_phi1= sin(phi *pi_180)
         endif


      enddo                     !      do iter=1,niter


      return
      end

